<?php
if (!defined('SMF'))
	die('No direct access...');

function ha_adminAreas(&$areas)
{
	global $txt;
	loadLanguage('HideAttach');
	$areas['config']['areas']['modsettings']['subsections']['ha'] = array($txt['ha_admin']);
}

function ha_modifyModifications(&$sub_actions)
{
	$sub_actions['ha'] = 'ha_settings';
}

function ha_settings(&$return_config = false)
{
	global $context, $smcFunc, $txt, $scripturl, $modSettings;
	
	loadLanguage('HideAttach');
	$context['page_title'] = $txt['ha_admin'];
	$context['settings_title'] = $txt['ha_admin'];
	$context['settings_message'] = $txt['ha_admin_desc'];
	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=ha';

	$opt='';
	$query = $smcFunc['db_query']('', '
		SELECT mg.id_group, mg.group_name
		FROM {db_prefix}membergroups mg',
		array()
	);
	
	$chkbidcount=0;
	
	if(isset($modSettings['ha_groups']))
		$selgroups=explode(',',$modSettings['ha_groups']);
	else 
		$selgroups=array();
	
	while ($row = $smcFunc['db_fetch_assoc']($query)) {
		$opt.='<input type="checkbox" class="haCheckBox" id="hachkbid'.$chkbidcount.'" value="'.$row['id_group'].'" onchange="gethaCheckedCheckBoxes()"'; 
		if (in_array($row['id_group'],$selgroups))
			$opt.=' checked';
		$opt.='>'.$row['group_name'].'<br>';
		$chkbidcount++;
	}
	$smcFunc['db_free_result']($query);

	$config_vars = array(
		array('check', 'ha_enable'),
		array('text', 'ha_groups', 'preinput' => '<div style="display:none;">', 'postinput' => '</div>'.$opt, 'subtext' => $txt['ha_admin_groups_desc']),
	);

	addInlineJavaScript('function gethaCheckedCheckBoxes() {
	var selectedCheckBoxes = document.querySelectorAll(\'.haCheckBox:checked\');
	var checkedValues = Array.from(selectedCheckBoxes).map(cb => cb.value);
	document.getElementById(\'ha_groups\').value=checkedValues.join();
	}');

	if ($return_config)
		return $config_vars;

	if (isset($_GET['save'])) {
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=modsettings;sa=ha');
	}
	prepareDBSettingContext($config_vars);
}

function popup(){
	global $context, $scripturl, $boardurl, $txt, $smcFunc, $modSettings, $user_info;
	loadLanguage('HideAttach');
	
	$opt='<input type="checkbox" class="haCheckBox" id="ha_popup_cb_all" name="ha_popup_cb_all" value="all"> ' . $txt['ha_any_user'] . '<br>';
	
	if(isset($modSettings['ha_groups'])){
		$query = $smcFunc['db_query']('', '
			SELECT mg.id_group, mg.group_name
			FROM {db_prefix}membergroups mg',
			array()
		);
		$chkbidcount=0;

		$selgroups=explode(',',$modSettings['ha_groups']);
		while ($row = $smcFunc['db_fetch_assoc']($query)) {
			if (in_array($row['id_group'],$selgroups))
				$opt.='<input type="checkbox" class="haCheckBox" id="hachkbid'.$chkbidcount.'" value="'.$row['id_group'].'">'.$row['group_name'].'<br>';
			$chkbidcount++;
		}
		$smcFunc['db_free_result']($query);
	}
	//ТОДО: окно сообщения об ошибках	
	echo'
	<div id="ha_popup" class="top_menu dropmenu" style="display: none; position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%);">
		<div id="err_msg" style="position: fixed; top: 50%; left: 50%; transform: translate(-50%, -50%); background: wheat;"></div>
			<fieldset id="ha_fs">
				<legend>',$txt['ha_popup_legend'],'</legend>
				<input id="haattach_id" name="haattach_id" hidden disabled>
				<input id="hagroups" name="hagroups" hidden disabled>
			    ',$txt['ha_popup_txt'],'<br>';

	echo '
				<br>
				<input type="checkbox" id="ha_popup_cb_none" name="ha_popup_cb_none"  onchange="if(this.checked){document.querySelectorAll(\'.haCheckBox\').forEach(function(item, i, arr) {  item.disabled=true;});}else{document.querySelectorAll(\'.haCheckBox\').forEach(function(item, i, arr) {item.disabled=false;
				});}"> ', $txt['ha_popup_cb_none'], '<br>';
	
	echo $opt,'
			</fieldset>
			<a class="button" onclick="{
			document.getElementById(\'ha_popup\').style.display=\'none\';
			}">', $txt['ha_cancel_butt'], '</a>';


	echo'
<script>

function sendXHR() {
	
	for(let blk of document.getElementsByClassName("attached_BBC")){
		var cuatid = blk.firstElementChild.value.match(/\[attach id=(\d+)/)[1]
		blk.lastElementChild.classList.add(\'hab_\'+cuatid);
		if (hiat && hiat.hasOwnProperty(cuatid)){
			blk.lastElementChild.innerHTML=\'<i class="main_icons error"></i>'.$txt['ha_butt'].'\';
		}
		else{
			blk.lastElementChild.innerHTML=\''.$txt['ha_butt'].'\';
		} 
		
	}
	
	let fData = new FormData();
	fData.append(\'uid\','.$context['user']['id'].');
	fData.append(\'haattach_id\',document.getElementById(\'haattach_id\').value);
	if(typeof hiatsec != \'undefined\')
		fData.append(\'haattach_sec\',hiatsec[document.getElementById(\'haattach_id\').value]);
	var checkedValues=null;
	if(document.getElementById(\'ha_popup_cb_none\').checked){
		fData.append(\'none\',true);
	}
	else{
		var selectedCheckBoxes = document.querySelectorAll(\'.haCheckBox:checked\');
		checkedValues = Array.from(selectedCheckBoxes).map(cb => cb.value);
		if(checkedValues.length==0){
			alert(\'Select something.\');
			return false;
		}
		fData.append(\'groups\',checkedValues.join());
	}
	
	var xhr = new XMLHttpRequest();
	xhr.open("POST", "'.$boardurl.'/index.php?action=haXHR");
	xhr.send(fData);
	document.getElementById(\'err_msg\').innerHTML=" '.$txt['ha_popup_applying'].' ";
	xhr.onreadystatechange = function() {
		if (this.readyState != 4){ return; }
		if (this.status == 200){
			if (this.responseText.indexOf(\'[DONE]\') != 0){
				document.getElementById(\'err_msg\').innerHTML=\''.$txt['ha_popup_error'].'\';
				return;
			}
	
			if(checkedValues != null){
				hiat[document.getElementById(\'haattach_id\').value]=checkedValues.join();
				document.getElementsByClassName(\'hab_\'+document.getElementById(\'haattach_id\').value)[0].innerHTML=\'<i class="main_icons error"></i>'.$txt['ha_butt'].'\';
			}
			else{
				if(typeof hiat != \'undefined\')
					delete window.hiat[document.getElementById(\'haattach_id\').value];
				document.getElementsByClassName(\'hab_\'+document.getElementById(\'haattach_id\').value)[0].innerHTML=\''.$txt['ha_butt'].'\';
			}
			document.getElementById(\'ha_popup\').style.display=\'none\';
		}
		else{
			document.getElementById(\'err_msg\').innerHTML=\''.$txt['ha_popup_net_error'].' \' + this.status + \' - \' + this.statusText + \' <br>\';
		}
	}
}
</script>';

	echo'
		<a class="button floatright" onclick="sendXHR()">', $txt['ha_aply_butt'], '</a>
	</div>';
}

function ha_action_XHR(&$actionArray)
{
	$actionArray['haXHR'] = array('hide_attachs.php', 'ha_process_XHR');
}

function ha_process_XHR()
{
	if(!isset($_POST['uid']) && !isset($_POST['haattach_id']) && (!isset($_POST['none']) || !isset($_POST['groups']))){
		loadLanguage('HideAttach');
		fatal_lang_error('ha_err_XHR', false);
	}
		
	global $context, $smcFunc, $db_connection;
	
	$query1 = $smcFunc['db_query']('', '
		SELECT `id_msg` FROM {db_prefix}attachments WHERE `id_attach`={int:id_attach}',
		array('id_attach' => (int) $_POST['haattach_id'],)
	);
	$row1 = $smcFunc['db_fetch_assoc']($query1); 
	if ($row1['id_msg']==0)
		$new_attach=true;
	
	$smcFunc['db_free_result']($query1);
		
	if(!isset($new_attach)){
		$sec='Your lucky number is 7352685223431656234754. Look for him everywhere!';

		if($_POST['haattach_sec'] == true || $_POST['haattach_sec']!=md5($context['user']['id'].$sec.$_POST['haattach_id'])){
			die('[ERROR] Security error');
		}
	}
	
	if(isset($_POST['none'])){
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}hidden_attachs 
			WHERE {db_prefix}hidden_attachs.`id_hattach` = {int:id_hattach}',
			array('id_hattach' => (int)$_POST['haattach_id'],));
	}
	else{
		$smcFunc['db_insert']('replace', '{db_prefix}hidden_attachs',
            array(
                'id_hattach' => 'int', 'groups' => 'string',
            ),
            array(
                (int)$_POST['haattach_id'], $smcFunc['db_escape_string']('1,' . $_POST['groups']),
            ),
            array('groups')
        );
	}

    if ($smcFunc['db_error']($db_connection)=='') {
		echo'[DONE]';
    }
	else {
	   echo'[ERROR]';
    }
	die();
}

?>